/* $Id: asm_386.h,v 3.2 1998/10/31 17:07:09 brianp Exp $ */

/*
 * Mesa 3-D graphics library
 * Version:  3.1
 * Copyright (C) 1995-1998  Brian Paul
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */


/*
 * $Log: asm_386.h,v $
 * Revision 3.2  1998/10/31 17:07:09  brianp
 * Josh's patches for 3.1
 *
 * Revision 3.1  1998/03/28 04:05:52  brianp
 * added CONST macro
 *
 * Revision 3.0  1998/01/31 20:45:56  brianp
 * initial rev
 *
 */


#ifndef ASM_386_H
#define ASM_386_H


#include "GL/gl.h"
#include "macros.h"
#include "types.h"

/*
 * Prototypes for assembly functions.
 */


extern void asm_transform_points3_general( CONST GLmatrix *matrix,
                                           GLuint count,
                                           CONST GLfloat *source,
                                           GLfloat dest[][4],
                                           GLuint stride );

extern void asm_transform_points3_identity( CONST GLmatrix *matrix,
                                            GLuint count,
                                            CONST GLfloat *source,
                                            GLfloat dest[][4],
                                            GLuint stride );

extern void asm_transform_points3_2d( CONST GLmatrix *matrix,
                                      GLuint count,
                                      CONST GLfloat *source,
                                      GLfloat dest[][4],
                                      GLuint stride );

extern void asm_transform_points3_2d_no_rot( CONST GLmatrix *matrix,
                                             GLuint count,
                                             CONST GLfloat *source,
                                             GLfloat dest[][4],
                                             GLuint stride );

extern void asm_transform_points3_3d( CONST GLmatrix *matrix,
                                      GLuint count,
                                      CONST GLfloat *source,
                                      GLfloat dest[][4],
                                      GLuint stride );

extern void asm_transform_points4_general( CONST GLmatrix *matrix,
                                           GLuint count,
                                           CONST GLfloat *source,
                                           GLfloat dest[][4],
                                           GLuint stride );

extern void asm_transform_points4_identity( CONST GLmatrix *matrix,
                                            GLuint count,
                                            CONST GLfloat *source,
                                            GLfloat dest[][4],
                                            GLuint stride );

extern void asm_transform_points4_2d( CONST GLmatrix *matrix,
                                      GLuint count,
                                      CONST GLfloat *source,
                                      GLfloat dest[][4],
                                      GLuint stride );

extern void asm_transform_points4_2d_no_rot( CONST GLmatrix *matrix,
                                             GLuint count,
                                             CONST GLfloat *source,
                                             GLfloat dest[][4],
                                             GLuint stride );

extern void asm_transform_points4_3d( CONST GLmatrix *matrix,
                                      GLuint count,
                                      CONST GLfloat *source,
                                      GLfloat dest[][4],
                                      GLuint stride );

extern void asm_transform_points4_3d_no_rot( CONST GLmatrix *matrix,
                                             GLuint count,
                                             CONST GLfloat *source,
                                             GLfloat dest[][4],
                                             GLuint stride );

extern void asm_transform_points4_perspective( CONST GLmatrix *matrix,
                                               GLuint count,
                                               CONST GLfloat *source,
                                               GLfloat dest[][4],
                                               GLuint stride );

extern void asm_cliptest_points4( GLuint n,
                                  CONST GLfloat vClip[][4],
                                  GLubyte clipMask[],
                                  GLubyte *orMask,
                                  GLubyte *andMask );
#endif
